使用 psycopg2 遇到的一些坑

坑1. 尽可能不要使用 psycopg2-binary

官方文档说了,psycopg2-binary 不需要编译,可以认为是绿色版,是为了初学者用 Python 快速和 PostgreSQL 进行连接而用的, 如果你在 pypi 上发包,也不应该依赖 psycopg2-binary,应该直接依赖 psycopg2。

我没听,直接再生产环境用了 psycopg2-binary,版本 2.7.5 ,结果就中招了,在使用 server-side-cursor (named cursor)的时候,经常出现读数据库卡住不动的情况,怀疑跟这个版本的 bug 有关系。

为啥不直接从源代码安装,因为总是报 pg_config not found 之类的错误,而生产环境,安装一个 postgresql-lib 是相当麻烦的。

我想这也是 python 的缺点之一,依赖的包很多需要编译,而编译就会出现缺少各种各样的包的问题,这样就不能称之为跨平台了,我在 mac 上写好,弄到 linux 上,还得折腾一大堆,java 这一点就很好。

最后怎么解决的呢,升级到最新版本的 psycopg2-binary 就解决了,如果再出现,只能老老实实安装 postgresql-lib。

坑1. 尽可能不要 pip install whl 文件

这次我离线下载了 psycopg2-binary 的文件,psycopg2_binary-2.8.6-cp36-cp36m-manylinux1_x86_64.whl

我分别试了两种方法,第二种成功:

方法一:

pip install psycopg2_binary-2.8.6-cp36-cp36m-manylinux1_x86_64.whl

方法一在执行 import psycopg2.extras 时报错,方法二没有。

方法二:

pip install psycopg2-binary --no-index -f ./

足以说明,使用 pip 最好还是联网环境。

推荐阅读更多精彩内容